package jp.co.sds_corp.fxutil;

import java.io.Serializable;
import java.util.Properties;

/**
* 通貨テーブル
* @author 小見山　聡
*/
public class Ccy implements Serializable
{
	private static final long serialVersionUID = 1L;
	Properties	prop = new Properties();

	/**
	* 通常は使用しないでください。
	*/
	public Ccy( String code ) {
		this.code = code;
	}

	public Ccy( String code, String name, String city, int point ) {
		this.code = code;
		this.name = name;
		this.city = city;
		this.point = point;
	}

	/**
	* このCcyと指定されたCcyを比較します。
	* @param	o	比較するオブジェクト
	* @return	等しい場合のみtrue
	*/
	public boolean equals( Object o ) {
		if ( !( o instanceof Ccy )) {
			return false;
		}
		Ccy cmp = (Ccy )o;
		if ( getCode().equals( cmp.getCode())) {
			return true;
		}
		return false;
	}

	/**
	* オブジェクトのハッシュコード値を返します。
	* @return	ハッシュコード値
	*/
	public int hashCode() {
		return code.hashCode();
	}

	public String toString() {
		return code;
	}

	/**
	* 指定されたキーと値を設定します。
	* @param	key		キー
	* @param	value	値
	* @return	以前に設定されている値。無ければnull
	*/
	public Object setProperty( String key, String value ) {
		Object ret = prop.setProperty( key, value );
		return ret;
	}
	/**
	* 指定されたキーを持つプロパティを、プロパティリストから探します。
	* @param	key		キー
	* @return	設定されている値
	*/
	public String getProperty( String key ) {
		String ret = prop.getProperty( key );
		return ret;
	}
	/**
	* 現在設定されているプロパティを取得します。
	* @return	設定されているプロパティ
	*/
	public Properties getProperties() {
		return prop;
	}

	String	code;
	String	name;
	String	city;
	int	point;

	/**
	* 通貨コード(code)を設定します。
	* @param	var		設定するデータ
	*/
	public void setCode( String var ) {
		this.code = var ;
	}
	/**
	* 通貨コード(code)を取得します。
	* @return	codeの内容
	*/
	public String getCode() {
		return code;
	}

	/**
	* 通貨名(name)を設定します。
	* @param	var		設定するデータ
	*/
	public void setName( String var ) {
		this.name = var ;
	}
	/**
	* 通貨名(name)を取得します。
	* @return	nameの内容
	*/
	public String getName() {
		return name;
	}

	/**
	* 都市コード(city)を設定します。
	* @param	var		設定するデータ
	*/
	public void setCity( String var ) {
		this.city = var ;
	}
	/**
	* 都市コード(city)を取得します。
	* @return	cityの内容
	*/
	public String getCity() {
		return city;
	}

	/**
	* 最小通貨単位桁数(point)を設定します。
	* @param	var		設定するデータ
	*/
	public void setPoint( int var ) {
		this.point = var ;
	}
	/**
	* 最小通貨単位桁数(point)を取得します。
	* @return	pointの内容
	*/
	public int getPoint() {
		return point;
	}

}
