package	jp.co.sds_corp.fxutil.cache;

import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import jp.co.sds_corp.fxutil.CcyPair;
import jp.co.sds_corp.fxutil.MasterCache;
import jp.co.sds_corp.fxutil.TermList;

/**
* 期間マスタのキャッシュです。
*/
public class TermCache
{
	Vector<String>	vecTerm = new Vector<String>();
	HashMap<CcyPair,Map<String,Date>>	mapTerm = new HashMap<CcyPair,Map<String,Date>>();

	public TermCache() {
		String[] terms = TermList.getDefaultTerms();
		for ( int i = 0; i < terms.length; i++ ) {
			vecTerm.add( terms[i] );
		}
	}

	public List<String> getDefaultTermList() {
		return vecTerm;
	}

	public Date getSpotDate( CcyPair pair ) {
		return getDate( pair, "SP" );
	}

	public Date getDate( CcyPair pair, String term ) {
		Map<String,Date> map = mapTerm.get( pair );
		if ( map == null ) {
			return null;
		}
		Date ret = (Date )map.get( term );
		return ret;
	}

	public void calcTerm() {
		MasterCache master = MasterCache.getInstance();
		Map<String,CcyPair> map = master.mapCcyPair();
		Iterator<CcyPair> itr = map.values().iterator();
		while ( itr.hasNext()) {
			CcyPair pair = (CcyPair )itr.next();
			calcTerm( pair );
		}
	}

	public void calcTerm( CcyPair pair ) {
		Map<String,Date> map = mapTerm.get( pair );
		if ( pair == null ) {
			map = new HashMap<String,Date>();
			mapTerm.put( pair, map );
		}
		map.clear();
		// @@@
	}

}
