package	jp.co.sds_corp.fxutil.service;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.HashMap;

import jp.co.sds_corp.fxutil.Ccy;
import jp.co.sds_corp.util.common.CmnString;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

/**
* 通貨マスタのローダです。
*/
public class CsvCcyLoader extends CsvLoader
{
	static final CmnLogger logger = CmnLogFactory.getLogger();

	public void init( IConfiguration config ) throws Exception {
		super.init( config );
		URL url;
		url = getUrl( config );
		if ( url != null ) {
			HashMap<String,Ccy> map = new HashMap<String,Ccy>();
			BufferedReader rd = new BufferedReader(
								new InputStreamReader( url.openStream()));
			for ( ;; ) {
				String buf = rd.readLine();
				if ( buf == null ) {
					break;
				}
				String[] line = CmnString.getStringToken( buf, "\t" );
				Ccy ccy = parseCcy( line );
				map.put( ccy.getCode(), ccy );
				if ( isDebug() ) {
					logger.debug( this, "add ccy [" + ccy + "]" );
				}
			}
			master.mapCcy().clear();
			master.mapCcy().putAll( map );
		}
	}

	protected Ccy parseCcy( String[] line ) throws Exception {
		String code = line[0];
		String name = line[1];
		String city = line[2];
		int point = Integer.valueOf( line[3] ).intValue();
		Ccy ccy = new Ccy( code, name, city, point );
		return ccy;
	}

}
