package	jp.co.sds_corp.fxutil.service;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.HashMap;

import jp.co.sds_corp.fxutil.Ccy;
import jp.co.sds_corp.fxutil.CcyPair;
import jp.co.sds_corp.util.common.CmnString;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

/**
* 通貨ペアマスタのローダです。
*/
public class CsvCcyPairLoader extends CsvLoader
{
	static final CmnLogger logger = CmnLogFactory.getLogger();

	public void init( IConfiguration config ) throws Exception {
		super.init( config );
		URL url;
		url = getUrl( config );
		if ( url != null ) {
			HashMap<String,CcyPair> map = new HashMap<String,CcyPair>();
			BufferedReader rd = new BufferedReader(
								new InputStreamReader( url.openStream()));
			for ( ;; ) {
				String buf = rd.readLine();
				if ( buf == null ) {
					break;
				}
				String[] line = CmnString.getStringToken( buf, "\t" );
				CcyPair pair = parseCcyPair( line );
				map.put( pair.getCcy1().getCode() + pair.getCcy2().getCode(), pair );
				if ( isDebug() ) {
					logger.debug( this, "add ccy_pair [" + pair + "]" );
				}
			}
			master.mapCcyPair().clear();
			master.mapCcyPair().putAll( map );
		}
	}

	protected CcyPair parseCcyPair( String[] line ) throws Exception {
		Ccy ccy1 = master.getCcy( line[0] );
		Ccy ccy2 = master.getCcy( line[1] );
		Ccy cross = master.getCcy( line[2] );
		boolean feed = line[3].equals( "Y" );
		int point = Integer.valueOf( line[4] ).intValue();
		int fwd = Integer.valueOf( line[5] ).intValue();
		CcyPair pair = new CcyPair( ccy1, ccy2, cross,
									feed, point, fwd );
		return pair;
	}

}
