package	jp.co.sds_corp.fxutil.service;

import java.io.File;
import java.net.URL;

import jp.co.sds_corp.fxutil.MasterCache;
import jp.co.sds_corp.util.config.IConfiguration;

/**
* CSVマスタのローダです。
*/
public class CsvLoader
{
	MasterCache	master = MasterCache.getInstance();
	boolean bDebug = false;

	public void init( IConfiguration config ) throws Exception {
		String var = config.getAttributes().get( "debug", "false" );
		if ( var != null && var.equals( "true" )) {
			bDebug = true;
		}
	}

	/**
	* デバッグフラグ(debug)を設定します。
	* @param	var		設定するデータ
	*/
	public void setDebug( boolean var ) {
		this.bDebug = var ;
	}
	/**
	* デバッグフラグ(debug)を取得します。
	* @return	debugの内容
	*/
	public boolean isDebug() {
		return bDebug;
	}

	protected URL getUrl( IConfiguration config ) throws Exception {
		URL url = null;
		String var = null;
		try {
			var = config.getAttributes().get( "File" );
		} catch ( Exception e ) {
		}
		if ( var != null ) {
			url = new File( var ).toURI().toURL();
		} else {
			try {
				url = new URL( config.getAttributes().get( "URL" ));
			} catch ( Exception e ) {
			}
		}
		return url;
	}

}
